diff --git a/contrib/ncurses/ANNOUNCE b/contrib/ncurses/ANNOUNCE
index e0603d622394..6abf551c684d 100644
--- a/contrib/ncurses/ANNOUNCE
+++ b/contrib/ncurses/ANNOUNCE
@@ -1,4 +1,4 @@
-                            Announcing ncurses 6.2
+                            Announcing ncurses 6.5
 
 Overview
 
@@ -40,19 +40,19 @@ Overview
 
    The ncurses distribution is available at ncurses' homepage:
 
-     ftp://ftp.invisible-island.net/ncurses/ or
+     https://invisible-island.net/archives/ncurses/ or
      https://invisible-mirror.net/archives/ncurses/ .
 
-   It is also available via anonymous FTP at the GNU distribution site
+   It is also available at the GNU distribution site
 
-     ftp://ftp.gnu.org/gnu/ncurses/ .
+     https://ftp.gnu.org/gnu/ncurses/ .
 
 Release Notes
 
-   These notes are for ncurses 6.2, released February 12, 2020.
+   These notes are for ncurses 6.5, released April 27, 2024.
 
    This  release  is  designed  to  be source-compatible with ncurses 5.0
-   through  6.1; providing extensions to the application binary interface
+   through  6.4; providing extensions to the application binary interface
    (ABI).  Although  the  source  can  still be configured to support the
    ncurses  5  ABI, the reason for the release is to reflect improvements
    to the ncurses 6 ABI and the supporting utility programs.
@@ -60,340 +60,192 @@ Release Notes
    There  are,  of  course,  numerous  other improvements, listed in this
    announcement.
 
-   The  most  important  bug-fixes/improvements  dealt  with user-defined
-   capabilities  in terminal descriptions. The release notes also mention
-   some other bug-fixes, but are focused on new features and improvements
-   to existing features since ncurses 6.1 release.
+   The   most  important  bug-fixes/improvements  dealt  with  robustness
+   issues.  The  release notes also mention some other bug-fixes, but are
+   focused  on  new  features and improvements to existing features since
+   ncurses 6.4 release.
 
   Library improvements
 
     New features
 
-   There are several new features:
-     * O_EDGE_INSERT_STAY  tells  the  form  library  to optionally delay
-       cursor movement on a field edge/boundary
-     * O_INPUT_FIELD  extension to form library allows a dynamic field to
-       shrink if the new limit is smaller than the current field size.
-     * added  exit_curses  and  exit_terminfo to replace internal symbols
-       for leak-checking.
-     * added curses_trace, to replace trace().
-
-   Additionally,  to  improve  performance other changes (and extensions)
-   are provided in this release:
-     * mouse  decoding  now handles shift/control/alt logic when decoding
-       xterm's 1006 mode
-     * ncurses  now  defines a limit for wgetnstr, wgetn_wstr when length
-       is negative or "too large".
-     * reordered  loop-limit checks in winsnstr in case the string has no
-       terminating null and only the number of characters is used.
-     * there  is  now  no  buffer-size  limit  when  reading the $TERMCAP
-       variable.
-     * the  $TERMCAP  variable  may  be  interpreted  as  a fallback to a
-       terminfo entry
-     * mvcur  now decides whether to use hard-tabs, using xt, tbc and hts
-       as clues.
-     * extended  colors  are  improved  by  modifying an internal call to
-       vid_puts  to pass extended color pairs e.g., from tty_update.c and
-       lib_mvcur.c
-     * the  initialization  functions  now  avoid relying upon persistent
-       data for the result from getenv
-     * scrolling is improved:
-          + a limit check in newline_forces_scroll handles the case where
-            the row is inside scroll-margins, but not at the end.
-          + improved loop limits in _nc_scroll_window handle a case where
-            the scrolled data is a pad which is taller than the window.
+   These are new features:
+     * The low-level terminfo and termcap interfaces are used both by the
+       higher-level curses library, as well as by many applications.
+       The  functions  which  convert  parameterized  terminal capability
+       strings  for output to the terminal (tiparm and tparm) analyze the
+       capability string to determine which parameters are strings (i.e.,
+       addresses), versus numbers (not addresses).
+       The  library's analysis of a capability string may differ from the
+       calling  application's design if environment variables are used to
+       point  to  an  invalid  terminal  database. This is a longstanding
+       problem  with  all  implementations  of  terminfo, dating from the
+       early 1980s.
+       Two  new  functions  address this problem: by providing a function
+       which  allows  the  calling  application  to tell ncurses how many
+       string-parameters to expect:
+          + tiscan_s  helps  applications  check  formatting capabilities
+            that would be passed to tiparm_s.
+          + tiparm_s provides applications a way to tell ncurses what the
+            expected parameters are for a capability.
+     * The  ncurses library supports a compile-time feature (enabled with
+       the   configure   --enable-check-size   option)  which  simplifies
+       initialization  with  terminals  which  do  not  negotiate  window
+       (screen)  size.  This is done in setupterm, by providing for using
+       ANSI cursor-position report (in user6/user7 terminfo capabilities)
+       to  obtain  the  screen  size  if neither environment variables or
+       ioctl is used.
+       The  ncurses  test-program  with options "-E -T" demonstrates this
+       feature.
+     * add functions to query tty-flags in SCREEN
+
+   This release drops compatibility with obsolete versions of tack, e.g.,
+   pre-1.08
 
     Other improvements
 
-   These are revised features:
-     * used  "const"  in  some prototypes rather than NCURSES_CONST where
-       X/Open  Curses  was updated to do this, e.g., wscanw, newterm, the
-       terminfo  interface.  Also  use  "const"  for  consistency  in the
-       termcap interface, which was withdrawn by X/Open Curses in Issue 5
-       (2007).  As  of  Issue  7,  X/Open  Curses still lacks "const" for
-       certain return values, e.g., keyname.
-     * modified  wbkgd  and  wbkgrnd  to  improve compatibility with SVr4
-       curses,  changing the way the window rendition is updated when the
-       background character is modified
-     * improved  terminfo  write/read by modifying the fourth item of the
-       extended  header  to  denote  the  number  of valid strings in the
-       extended string table (see term(5)).
-     * modified   the   initialization  checks  for  mouse  so  that  the
-       xterm+sm+1006  block  will  work  with  terminal  descriptions not
-       mentioning xterm.
-
-   These were done to limit or ultimately deprecate features:
-     * deprecated  safe-sprintf, since the vsnprintf function, which does
-       what was needed, was standardized long ago.
-     * marked   vwprintw  and  vwscanw  as  deprecated;  recommend  using
-       vw_printw and vw_scanw, respectively.
-     * added  deprecation warnings for internal functions called by older
-       versions of tack.
-     * removed unused _nc_import_termtype2 function.
-
    These are improvements to existing features:
-     * check parameter of set_escdelay, return ERR if negative.
-     * check  parameter  of  set_tabsize,  return ERR if not greater than
-       zero
-     * correct  a status-check in _nc_read_tic_entry() so that if reading
-       a hex/b64 $TERMINFO, and the $TERM does not match, fall-through to
-       the compiled-in search list.
-     * amend check for repeat_char to handle a case where setlocale() was
-       called after initscr
-     * move macro for is_linetouched inside NCURSES_NOMACROS ifndef.
-     * use _nc_copy_termtype2 rather than direct assignment in setupterm,
-       in   case   it   is  called  repeatedly  using  fallback  terminfo
-       descriptions
-     * improve   workaround   for  Solaris  wcwidth  versus  line-drawing
-       characters
-     * add  checks  in repair_subwindows to keep the current position and
-       scroll-margins inside the resized subwindow.
-     * correct  a  buffer-limit  in  write_entry.c  for  systems that use
-       caseless filenames.
-     * improved build-time utility report_offsets:
-          + add categories, e.g., "w" for wide-character, "t" for threads
-            to  make the report more readable. Reorganized the structures
-            reported to make the categories more apparent.
-          + add  NCURSES_GLOBALS  and NCURSES_PRESCREEN to report to show
-            how similar the different libtinfo configurations are.
-     * modified  some header files to ensure that those include necessary
-       files except for the previously-documented cases
-     * added  some  traces  in  initialization to show whether a fallback
-       entry is used.
-     * made minor optimization to reduce calls to _nc_reserve_pairs
+     * In  addition  to  the  new,  safer function tiparm_s, ncurses adds
+       checks to make the older tiparm, tparm and tgoto functions safer:
+          + the  terminfo  functions  tiparm  and  tparm  ensure that the
+            capability  string  comes from the terminal description which
+            ncurses  loads,  rather  than  from  random  data  which  the
+            application happens to have.
+          + the  tgoto function disallows capabilities which its analysis
+            shows will attempt to use string parameters.
+          + ncurses  uses  internal functions which correspond to tiparm,
+            and  tgoto which ensure that the capability strings which are
+            passed  to  these  functions  come  from  the loaded terminal
+            description.
+     * improve  check  in  lib_tparm.c, ensuring that a char* fits into a
+       TPARM_ARG
+     * modify  _nc_syserr_abort  to  use _nc_env_access, rather than only
+       checking root uid
+     * improve thread lock in lib_trace.c
+     * modify  flushinp  to  use  file descriptors in SCREEN, rather than
+       from TERMINAL, and check if they are for a terminal, like SVr4
+     * modify mcprint to use file descriptor in SCREEN, for consistency
+     * modify  internal  function  _nc_read_file_entry  to  show relevant
+       filename in warnings
+     * improve  checks  in  internal  function convert_string for corrupt
+       terminfo entry
+     * review/improve handling of out-of-memory conditions
+     * limit  delays  to 30 seconds, i.e., padding delays in terminfo, as
+       well as napms and delay_output functions
+     * fix  reallocation  loop  for  vsnprintf  in  _nc_sprintf_string by
+       copying the va_list variable
+     * modify  delscreen  to  limit  the windows which it creates to just
+       those associated with the screen
+     * modify  endwin to return an error if it is called again without an
+       intervening screen update
+     * modify wenclose to handle pads
+     * eliminate use of PATH_MAX in lib_trace.c
+     * provide for any CCHARW_MAX greater than 1
 
    These are corrections to existing features:
-     * fix  a  special  case  in  PutAttrChar  where  a cell is marked as
-       alternate-character  set,  but  the  terminal  does  not  actually
-       support the given graphic character. This would happen in an older
-       terminal such as vt52, which lacks most line-drawing capability.
-     * corrected  flag  for "seq" method of db 1.8.5 interface, needed by
-       toe on some of the BSDs.
-     * modify  comparison  in  make_hash.c  to  correct a special case in
-       collision handling for Caps-hpux11
-     * add    extended_slk_color{,_sp}   symbols   to   the   appropriate
-       package/*.{map,sym} files
-     * modify  lib_setup  to  avoid  calling pthread_self() without first
-       verifying that the address is valid, i.e., for weak symbols
-     * add  a  couple  of  broken-linker symbols to the list of versioned
-       symbols to help with link-time optimization versus weak symbols.
+     * correct loop termination condition in waddnstr and waddnwstr
+     * improve  parsing  in  internal  function _nc_msec_cost, allowing a
+       single decimal point
+     * amend  parameter check for entire string versus specific length in
+       winsnstr  and wins_nwstr to match Solaris; make similar correction
+       to wins_nwstr
+     * correct   internal   function   wadd_wch_literal   when  adding  a
+       non-spacing character to a double-width character
+     * correct  definition of Charable macro for non-wide ncurses library
+       .
 
   Program improvements
 
-   Several improvements were made to the utility programs:
-
-   clear
-
-          + improved  logic  for  clearing with the E3 extension, in case
-            the  terminal  scrolls  content  onto  its saved-lines before
-            actually  clearing  the  display, by clearing the saved-lines
-            after clearing the display
+   Several improvements were made to the utility programs. Some were done
+   to  make  the  infocmp  option  "-u" option help refactor the terminal
+   database.
 
    infocmp
 
-          + omit  filtering  of  "OTxx" names which are used for obsolete
-            capabilities,  when  the output is sorted by long-names. This
-            change helps when making a table of the short/long capability
-            names.
+          + add  limit  checks  for processing extended capabilities with
+            the "-u" option
+          + correct  initial  alignment of extended capabilities, so that
+            the "-u" option can be used for more than two terminal types
+          + modify  "-u"  option  to not report cancels for strings which
+            were already cancelled in a use'd chunk.
+          + correct  an  assignment  "-u"  for  detecting if a boolean is
+            unset  in  a base entry and set in a use'd chunk, i.e., if it
+            was cancelled.
 
    tic
 
-          + added   check   for   consistent   alternate   character  set
-            capabilities.
-          + added check for paired indn/rin.
-          + added check for terminals with parm_dch vs parm_ich.
-          + added  check  for  the  case  where setf/setb are given using
-            different   strings,   but   provide   identical  results  to
-            setaf/setab.
-          + corrected check for ich1.
-          + changed  a  too-large  terminal entry from a fatal error to a
-            warning.
-
-   toe
-
-          + ignores  any  hex/b64 $TERMINFO value in the list of terminfo
-            databases.
-
-   tset
-
-          + replace  check  in reset command for obsolete "pt" capability
-            using tbc and hts capabilities as clues
-          + modify reset to allow for tabstops at intervals other than 8.
-          + change   reset's   behavior   for  margins  to  simply  clear
-            soft-margins  if  possible,  rather  than  clearing  and then
-            setting them according to the terminal's width.
-
-   tput
-
-          + add "x" to getopt string so that "tput -x clear" works.
-
-   Several  changes were made to the generated ncurses*config scripts and
-   the   analogous   ".pc"   files  to  reduce  differences  between  the
-   configurations they report:
-     * modified the ncurse*-config and pc-files to more closely match for
-       the -I and -l options.
-     * filtered out linker-specs from the --libs report.
-     * amended  the ncurses*-config and pc-files to take into account the
-       rpath hack which differed between those files.
-     * modified  generated  ncurses*config  and  ncurses.pc, ncursesw.pc,
-       etc., to list helper libraries such as gpm for static linking.
+          + correct limit-check when dumping tc/use clause via "-I"
+          + check  return  value  of  _nc_save_str, in special case where
+            extended   capabilities   are   processed  but  the  terminal
+            description was not initialized
+          + modify  check for multiply defined aliases to report problems
+            within  the  current  runtime  rather than for conflicts with
+            pre-existing terminal descriptions.
+          + disallow  using $TERMINFO or $HOME/.terminfo when "-o" option
+            is used
+
+   tput and tset
+
+          + add "-v" option to tput, to show warnings
+          + modify reset command to avoid altering clocal if the terminal
+            uses a modem
+          + modify  reset feature to avoid 1-second sleep if running in a
+            pseudo-terminal
 
     Examples
 
    Along  with  the  library and utilities, improvements were made to the
-   ncurses-examples.  Most  of  this  activity  aimed  at  improving  the
-   test-packages.  A few changes are more generally useful, e.g., for the
-   main   ncurses  test-program,  and  for  analyzing  traces  using  the
-   tracemunch script:
-     * improve  recovery  from  error  when  reading command-character in
-       test/ncurses.c, showing the relevant error message and not exiting
-       on EINTR.
-     * improve  tracemunch,  by keeping track of TERMINAL* values, and if
-       tracing  was first turned on after initialization, attempt to show
-       distinct screen, window and terminal names anyway.
-     * modify tracemunch to accept filename parameters in addition to use
-       as a pipe/filter.
-     * update  tracemunch  to  work  with  perl 5.26.2, which changed the
-       rules for escaping regular expressions.
-     * add some checks in tracemunch for undefined variables.
-     * modify TurnOn/TurnOff macros (in lib_vidattr.c and lib_vid_attr.c)
-       to avoid expansion of "CUR" in trace.
-
-   There are other new demo/test programs and reusable examples:
-
-   color_content
-          Demonstrate   the   color_content   and  extended_color_content
-          functions.
-
-   demo_tabs
-          A simple demo of tabs in curses.
-
-   dump_window
-          A  portable  curses screen-dump, used to compare ncurses screen
-          contents with Solaris.
-
-   pair_content
-          Demonstrate    the   pair_content   and   extended_pair_content
-          functions.
-
-   report_hashing
-          Check hash-tables used for terminfo and termcap names.
-
-   parse_rgb
-          Sample   implementation  of  the  ncurses  RGB  extension  from
-          user_caps.5, used in picsmap and savescreen programs.
-
-   A  variety  of  improvements  were made to existing programs, both new
-   features  as  well  as  options added to make the set of programs more
-   consistent.
-     * add  "-l"  option to test/background, to dump screen contents in a
-       form that lets different curses implementations be compared.
-     * add  "@"  command  to  test/ncurses F-test, to allow rapid jump to
-       different character pages.
-     * added enum, regex examples to test/demo_forms
-     * amend  Scaled256() macro in test/picsmap.c to cover the full range
-       0..1000
-     * corrected  pathname used in Ada95 sample programs for explain.txt,
-       to  work  with  test-packages, and used an awk script to split the
-       resulting pathname when it would be too long for a single line.
-     * ignore  interrupted  system-call  in  test/ncurses's command-line,
-       e.g., if the terminal were resized.
-     * improved  ifdef's  for  TABSIZE  variable,  to  help with AIX/HPUX
-       ports.
+   ncurses-examples:
+     * modify test_tparm to account for extended capabilities
+     * corrected mouse mask in test/testcurs.c
+     * modify test/clip_printw.c to optionally test non-wrapped updates
+     * modify test/test_mouse.c to use curses api for raw/noraw
+     * modify test/clip_printw.c to optionally test non-wrapped updates
+
+   There is one new demo/test programs:
+
+   test/test_endwin.c
+          This program shows the return-status from endwin with different
+          combinations of endwin (repeated), initscr, newterm.
 
   Terminal database
 
    There are several new terminal descriptions:
-
-     alacritty,  domterm,  kitty,  mintty,  mintty-direct,  ms-terminal,
-     n7900,   nsterm-build309,  nsterm-direct,  screen5,  ti703,  ti707,
-     ti703-w, ti707-w vscode, vscode-direct, xterm-mono, xterm.js
+     * ansi+apparrows
+     * contour
+     * linux+kbs for terminals which imitate xterm's behavior with Linux
+     * rio, rio-direct
+     * mostlike
+     * ms-vt100-16color, winconsole
+     * vt100+noapp,   vt100+noapp+pc,  xterm+app+pc,  xterm+decedit  from
+       xterm #389
+     * putty+cursor to reflect amending of modified cursor-keys in 2021
+     * wezterm
 
    There  are  many  changes to existing terminal descriptions. Some were
-   updates to several descriptions:
-     * use ansi+rep in a dozen places
-     * add rs1 to konsole, mlterm
-     * improve several flash capabilities with trailing mandatory delays
-     * drop   ich1   from   rxvt-basic,   Eterm  and  mlterm  to  improve
-       compatibility with old non-curses programs
-     * add/use xterm+keypad in xterm-new
-     * use xterm+sl-twm for consistency, nine places
-     * improve xm example in xterm+x11mouse and xterm+sm_1006.
-
-   while  others  affected specific descriptions. These were retested, to
-   take into account changes by their developers:
-
-     terminator, st
-
-   while  these are specific fixes based on reviewing documentation, user
-   reports, or warnings from tic:
-
-   adds200:
-
-          + fix typo
-
-   gnome-256color
-
-          + base entry on "gnome", not "vte", for consistency
-
-   interix
-
-          + trim unnecessary setf/setb
-
-   linux-16color
-
-          + accommodate  Linux  console driver incompatibility introduced
-            in early 2018
-
-   nsterm-256color:
-
-          + add nsterm-build309 to replace nsterm-256color, assigning the
-            latter  as  an  alias  of  nsterm,  to  make  mouse work with
-            nsterm-256color
-
-   regent40:
-
-          + renumber function-keys to match manual
-
-   regent60:
-
-          + add cd (clr_eos)
-          + corrected acsc
-          + add shifted function-keys
-
-   tvi950:
-
-          + added  function-key  definitions  to agree with Televideo 950
-            manual
-          + corrected acsc
-          + remove bogus kf0
-          + add bel
-
-   tvi955:
-
-          + fix typo
-
-   vi200:
-
-          + add acsc string, including right/down-arrow
-
-   wy50:
-
-          + corrected acsc
-
-   wy50 and wy60:
-
-          + add shifted function-keys as kF1 to kF16
-
-   xterm+x11hilite:
-
-          + eliminate unused p5 parameter.
-
-   A few entries use extensions (user-defined terminal capabilities):
-     * use  xterm+sm+1006  (aka  "SGR  1006  mouse") for konsole-base and
-       putty
-     * add Smol/Rmol user-defined capability to tmux and vte-2018
-     * add Smulx user-defined capability to tmux, vte-2018
+   updates  to  several  descriptions, using the infocmp "-u" option in a
+   script  to  determine  which  building-block  entries could be used to
+   replace multiple capability settings (and trim redundant information).
+
+   Other changes include:
+     * document XF, kxIN and kxOUT
+     * add note on sun regarding wscons/cmdtool/shelltool
+     * remove DECCOLM+DECSCLM from foot
+     * add xterm+focus to foot+base
+     * add ecma+strikeout to putty
+     * use CSI 3J in vte-2017
+     * use oldxterm+sm+1006 in vte-2014
+     * modify xgterm to work around line-drawing bug
+     * add  xterm  focus  mode 1004 to xterm+focus as fe/fd capabilities,
+       like vim.
+     * add xterm+focus to alacritty+common
+     * add  XR/xr,  to work with vim, and use RV/rv to denote DA2 and its
+       response
+     * add  XF  flag  to  xterm+focus so that termcap applications can be
+       aware of terminals which may support focus in/out
+     * use xterm+focus in xterm-p370 and tmux
+     * remove xterm+sm+1006 from tmux
+     * NetBSD-related fixes for x68k and wsvt25
 
   Documentation
 
